/**
 * @author Immo Schulz-Gerlach
 * Lehrgebiet Software Engineering
 * FernUniversitt Hagen
 * @version 1.0
 */
import java.awt.*;
import java.util.*;
import com.umlet.control.*;
import com.umlet.element.base.Entity;

public class ActivityBorder extends com.umlet.element.base.Entity {

  // Change this method if you want to edit the graphical 
  // representation of your custom element.
  public void paint(Graphics g) {

    // Some unimportant initialization stuff; setting color, font 
    // quality, etc. You should not have to change this.
    Graphics2D g2=(Graphics2D) g; g2.setFont(Constants.getFont());
    g2.setColor(_activeColor); Constants.getFRC(g2);


    // It's getting interesting here:
    // First, the strings you type in the element editor are read and
    // split into lines.
    // Then, by default, they are printed out on the element, aligned
    // to the left.
    // Change this to modify this default text printing and to react
    // to special strings
    // (like the "--" string in the UML class elements which draw a line).
    Vector tmp=Constants.decomposeStrings(this.getPanelAttributes(), "\n");
    int yPos=Constants.getDistLineToText();
    int yZeile2=0;
    int xPrePost=0;
    //String pre=null;
    //String post=null;
    Vector<String> pre= new Vector<String>();
    Vector<String> post= new Vector<String>();
    for (int i=0; i<tmp.size(); i++) {
      String s=(String)tmp.elementAt(i);
      if (i==0) {
	      Font bold = Constants.getFont().deriveFont(Font.BOLD);
	      g2.setFont(bold); //Erste Zeile: ActivityName => Fettdruck.
      }
      if (s.startsWith("pre="))
	      pre.addElement(s.substring(4).trim());
	      //pre = s.substring(4).trim();
      else if (s.startsWith("post="))
	      post.addElement(s.substring(5).trim());
	      //post = s.substring(5).trim();
      else { //Text ausgeben
	      yPos+=Constants.getFontsize();
	      Constants.write(g2,s,Constants.getFontsize(), yPos, false);
	      yPos+=Constants.getDistTextToText();
	      xPrePost = Math.max(xPrePost, Constants.getPixelWidth(g2,s+"XXX"));
      }
      if (i==0) {
	      g2.setFont(Constants.getFont()); //Weitere Zeilen wieder in normaler Schrift (nicht fett)
	      yPos += Constants.getDistLineToText(); //Mehr Abstand zwischen ActivityName und Rest.
	      yZeile2=yPos + Constants.getFontsize();
      }
    }
    //Finally: Pre und Postcondition ausgeben
    yPos=yZeile2;
    int xCondition = xPrePost + Constants.getPixelWidth(g2,"<postcondition>>");
    //if (pre!=null) {
    Iterator<String> it = pre.iterator();
    if (it.hasNext()) {
	Constants.write(g2,"<<precondition>>", xPrePost, yPos, false);
	while (it.hasNext()) {
		Constants.write(g2, it.next(), xCondition, yPos, false);
		yPos += Constants.getDistTextToText()+Constants.getFontsize();
	}
    }
    //if (post!=null){
	//Constants.write(g2,"<<postcondition>>", xPrePost, yPos, false);    
	//Constants.write(g2, post, xCondition, yPos, false);
    //}
    it = post.iterator();
    if (it.hasNext()) {
	Constants.write(g2,"<<postcondition>>", xPrePost, yPos, false);
	while (it.hasNext()) {
		Constants.write(g2, it.next(), xCondition, yPos, false);
		yPos += Constants.getDistTextToText()+Constants.getFontsize();
	}
    }

    // Finally, change other graphical attributes using
    // drawLine, getWidth, getHeight..
    //g2.drawLine(0,0,this.getWidth()-1,0);
    //g2.drawLine(this.getWidth()-1, 0, this.getWidth()-1, this.getHeight()-1);
    //g2.drawLine(this.getWidth()-1, this.getHeight()-1, 0, this.getHeight()-1);
    //g2.drawLine(0, this.getHeight()-1, 0, 0);
    g2.drawRoundRect(0,0,this.getWidth()-1,this.getHeight()-1,Constants.getFontsize()*2, Constants.getFontsize()*2);
  }


  // Change this method if you want to set the resize-attributes of
  // your custom element
  public int getPossibleResizeDirections() {
    // Remove from this list the borders you don't want to be resizeable.
    return Constants.RESIZE_TOP | Constants.RESIZE_LEFT | Constants.RESIZE_BOTTOM | Constants.RESIZE_RIGHT;
  }


  // Advanced: change this method to modify the area where relations
  // stick to your custom element.
  public StickingPolygon getStickingBorder() {
    // By default, the element returns its outer borders. Change it,
    // if your element needs to stick to relations differently.
    // See, for example, the source code of the UML interface element.
    return null;
  }
}
