/**
 * @author Markus Muckhoff
 * Lehrgebiet Software Engineering
 * FernUniversitt Hagen
 * @version 1.0
 */
 
import java.awt.*;
import java.util.*;
import com.umlet.control.*;
import com.umlet.element.base.Entity;

public class BigState extends com.umlet.element.custom.State {

	public void paint(Graphics g) {
		
		Graphics2D g2=(Graphics2D) g;
		g2.setFont(Constants.getFont());
		g2.setColor(_activeColor);
		Constants.getFRC(g2);
		
		Vector tmp=Constants.decomposeStrings(this.getPanelAttributes(), "\n");
		
		g2.drawRoundRect(0,0,this.getWidth()-1,this.getHeight()-1,30,30);
		
		int i=0;
		while(i<tmp.size())
		{
			String StrTmp = (String) tmp.elementAt(i);
			if(StrTmp.equals("boldBorder"))
			{
				g2.drawRoundRect(1,1,this.getWidth()-3,this.getHeight()-3,29,29);
				tmp.remove(i);
			}
			else
				i++;
		}
		
		int yPos=0;
		yPos=this.getHeight()/2-tmp.size()*(Constants.getFontsize()+Constants.getDistTextToText())/2;

		for (i=0; i<tmp.size(); i++) {
			String s = (String) tmp.elementAt(i);
			yPos+=Constants.getFontsize();
			Constants.write(g2,s,(int)this.getWidth()/2, yPos, true);
			yPos+=Constants.getDistTextToText();
		}

		
	}

}
